/**
 * Background for the lockpicking minigame.
 * @param {string} id Scene id. Used to create controllers.
 * @param {string} key Unique key-space for the lockpicking minigame.
 */
function LockPickingBackground(id, key) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var uniqueIdentifier = arguments.callee.name;
    var elementId = id + "_" + key + "_" + uniqueIdentifier;
    
    var image = new LockPickingPreloadingBackground();

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML required for the minigame.
     */
    this.build = function () {
        var element = `<img class="background" src=${image.url} id="${elementId}">`;
        return element;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {

    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return image.preload();
    };
}

