/**
 * Outside section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoOutsideBatheGood(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = false;
    var reqController = false;
    var subController = ctrl.preStage;
    var changeController = ctrl.batheGood;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.stage;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.goodBathe = true;
        var injected = ctrl.gag.has();
        var neither = ctrl.potion.get() === SlaveNoonTwoGoodPotionChoice.NEITHER;
        var fucked = global.kobold.history.shared.enslavement.captureFucked;
        var eager = global.kobold.history.shared.enslavement.noonTwo.kissedBallsEager;
        var kissedBalls = global.kobold.history.shared.enslavement.noonTwo.kissedBalls || eager;
        var name = ctrl.misc.name();
        var toReturn = `[p]
                            Darnit.
                            Why couldn't the wolf have brought you to the river instead?!
                            Do you really have to wash up in the [b]middle[/b] of the hamlet, with all these people watching?
                            In a shallow [b]trough[/b] used by beasts of burden to slake their thirst?
                            You ${injected ? `sigh internally` : `let out another sigh`}.
                            You'd rather have some [b]privacy[/b] and the comfort of [b]running[/b] or at least [b]fresh[/b] water,
                            instead of this stale puddle of [b]animal spit[/b].
                        [/p]
                        [p]
                            But you don't get a say in the matter.
                            Either you wash up here, or not at all.
                            ${fucked ? `${eager ? `While you wear Fenrir's dried spunk with pride,
                            it would still be nice to clean off the rest of the dirt.` : `You're eager to rid yourself of
                            Fenrir's dried spunk.`}` : `It would be nice to clean off all the dirt from the chase.`}
                            Besides, it's a drinking trough.
                            You're probably [i]overreacting[/i].
                            There'll certainly be plenty of fresh, cool water underneath the filthy [i]top layer[/i].
                            Either way, you doubt the canine will change his mind on forcing you to bathe here,
                            especially considering the [i]auction[/i] is supposed to start soon.
                        [/p]
                        [p]
                            Reluctantly, you lift your foot off the ground, move it towards the trough, and dip it into the liquid.
                            The fluid feels [b]thick[/b], [b]warm[/b] and [b]sticky[/b], not just on the surface, but for at least an entire [b]inch[/b] deep.
                            Like a whole [b]layer[/b] of revolting animal drool coating your foot.
                            While appalled, you're in too far to back down now.
                            You press on, planting your sole on the wooden bottom of the trough.
                            At least the water is a [i]bit[/i] less [b]viscous[/b] and a hint [b]cooler[/b] near the bottom.
                        [/p]
                        [p]
                            Disgust visible on your face, you gingerly place your second foot into the makeshift tub.
                            A faint, unpleasant smell wafts forth from the fluid at your feet.
                            You look back at Fenrir, wordlessly pleading with him.
                            Do you [b]really[/b] have to do this?
                            The wolf's stern glare is unrelenting.
                            "[color=gblue]Hurry up. People are waiting.[/color]"
                        [/p]
                        [p]
                            With great hesitation, you lower your body into the water, your bare butt sinking through the slimy spit to the bottom of the trough.
                            You can feel the sickening feral saliva clinging to your loins, even when submerged into the clear part of the water,
                            along with more than a few mushy bits of half-digested grass.
                            Wanting to get this over with as fast as possible, if only to sate the wolf,
                            you dip your hands into the liquid, reaching as low as possible to collect as much of the [i]actual[/i] water as you can.
                            Still, you scoop up more [b]drool[/b] and [b]fur[/b] than anything else.
                        [/p]
                        [p]
                            Your stomach is churning, but you endure, smearing the slimy goop along your arms, [i]washing[/i] yourself with horse slobber.
                            You look behind you.
                            Fenrir seems pleased.
                            "[color=gblue]Carry on.
                            I'm going to leave you to it while I put on some clothes.
                            Try to run, if you [b]dare[/b].
                            We'll find you before you manage to reach the city [b]or[/b] the forest.
                            And when we do, the only thing we'll be selling'll be your [b]dried meat[/b].[/color]"
                        [/p]
                        [p]
                            With those words, the wolf turns tail, and casually begins to walk away.
                            Before he turns the corner back to the caravan, he lingers for a bit to stare at you, signalling for you to continue washing.
                            Dumbstruck, you gather more spit-water, and splatter it over your chest.
                            The saliva-ridden fluid is thick enough for you to [b]smear[/b] it over you body.
                            The act seems to satisfy the canine's lax suspicions.
                            He returns to the caravan, leaving you all to yourself, sitting naked in a watering trough in the middle of the hamlet.
                        [/p]
                        [p]
                            In a weird way, it's like Fenrir somewhat [i]trusts[/i] you not to try to run away or something.
                            Then again, he's right.
                            You have no way to escape.
                            If the farmers leering at you don't stop you themselves,
                            then they'll surely be able to tell the [b]bandits[/b] that'll be chasing after you where you went.
                        [/p]
                        [p]
                            Even [i]if[/i] you managed to make it past the farmers,
                            there's little cover between here and the city.
                            A few patches of woodland, none big enough to hide you for long.
                            Unless you fancy swimming across the wide river, there's only three ways to get back to the forest,
                            all three of which they'll undoubtedly guard.
                            If it were summer, at least you'd be able to conceal yourself in the growing grain.
                            But it's winter.
                            The fields are barren.
                        [/p]
                        [p]
                            You can't outrun them, as the wolf demonstrated yesterday, and there's nowhere to hide around here.
                            Fleeing would be a bad idea.
                            But that doesn't mean you have to sit here in this [i]slop[/i].
                            To make sure Fenrir can't say you didn't at least [i]try[/i] to clean yourself,
                            you slather some of the saliva-mixture onto your back, then you rise to your feet as quickly as you can, and you step out of the tub.
                        [/p]
                        [p]
                            Spit slowly oozes from your body, the viscous liquid inching its way down your scales, onto the ground.
                            To your surprise, it's actually quite [i]efficient[/i] at removing the dried up dirt${fucked ? `, dust and cum` : ` and dust`} from your body.
                            Even the bits of grass and fur get swept away.
                            The smell of the stuff, sadly, lingers on your scales, but it's mild enough to be passed off as [i]body odor[/i].
                            While it was one of the most unpleasant things you've ever done,
                            ${injected ? `surpassed only by taking the wolf's filthy underwear into your mouth,` : ``}
                            you've actually managed to get out of the slobber-rich drinking trough slightly more clean than you were before.
                        [/p]
                        [p]
                            Contemplating your next move, a familiar figure suddenly rushes towards you.
                            The caravan master.
                            "[color=brown]Ah, there you are, slave.
                            I was beginning to fear Fenrir had run off with you.
                            Where the hell is that mangy pooch anyway?
                            Did he leave you all alone?![/color]"
                            The human harrumphs angrily.
                            You don't dare interrupt him.
                            "[color=brown]The baron will hear of this.[/color]"
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
