/**
 * Proposition section of Enslavement, Noon Two.
 * @param {SlaveNoonTwoController} controller The Enslavement, Noon Two controller.
 */
function SlaveNoonTwoGoodAttack(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = SlaveNoonTwoOfferChoice.ATTACK;
    var reqController = ctrl.offer;
    var subController = ctrl.preGag;
    var changeController = ctrl.goodAttack;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.notGagged;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.enslavement.noonTwo.attacked = true;
        var toReturn = `[p]
                            A million thoughts run through your head.
                            If you decline, you won't gain the wolf's favor.
                            But you are [b]very[/b] certain that [i]if[/i] you do this,
                            it'll just lead to Fenrir asking [b]more[/b] and [b]more[/b] of you.
                            If you give in now, he'll keep pushing and pushing until you're his personal [b]concubine[/b] or something equally distasteful.
                            You don't want that.
                        [/p]
                        [p]
                            Consequences be damned, you're [b]not[/b] doing this.
                            He can threaten to have his men [b]violate[/b] you all he'd like.
                            At least that way, you won't have to be his [b]personal[/b] fucktoy.
                            While you [i]are[/i] sort of still frightened of what his gang might do to you,
                            and you [b]definitely[/b] hope he was [b]bluffing[/b] when he said that thing about the [i]dog[/i],
                            you think you've found the courage to stand up to the big, imposing predator.
                        [/p]
                        [p]
                            Anger wells up inside of you.
                            You aren't backing down.
                            Not this time.
                            In fact, with Fenrir's nude groin so close to your face, you spot an [i]opportunity[/i].
                            You could easily [b]bite down[/b] on his most sensitive bits,
                            and then, while he's writhing in pain, you can make a quick getaway.
                            [i]Excellent idea.[/i]
                        [/p]
                        [p]
                            Staring upwards at the lupine with a mischievous grin on your face,
                            you open your muzzle wide, and slowly approach his hefty balls with your snout.
                            Instead of going in for a kiss, you bring your sharp teeth to bear, 
                            intent on [b]chomping[/b] off a piece of the bandit's nutsack.
                            The wolf is not as ignorant as you believed him to be, however.
                            Or maybe you were too [i]eager[/i] to properly hide your true intentions.
                            Right before your fangs can sink into his loins,
                            he slams your forehead with the flat of his large palm,
                            harshly pushing you backwards, your muzzle snapping shut,
                            catching nothing but [i]air[/i] in between your teeth.                       
                        [/p]
                        [p]
                            Surprised by your plan's failure, you are suddenly filled with rage.
                            You close your eyes and begin to wildly [b]flail around[/b],
                            swinging your claws about every which way, hoping you'll strike a lucky hit.
                            Fenrir keeps you at bay by simply holding you by your forehead,
                            keeping you at arm's length like a parent would its unruly child.
                            That is, after all, what you are acting like: a [b]child[/b],
                            lashing out because it did something bad, one that doesn't [i]want[/i] to face the consequences of its actions.
                        [/p]
                        [p]
                            After nearly half a minute of hitting nothing but air, your angry, impotent rampage slowly comes to an end.
                            You open your eyes once more, a few frustrated tears rolling down your cheeks.
                            All the while, a sadistic grin is plastered across the canine's face.
                            "[color=gblue]You could have just said [i]no[/i], instead of [b]embarrassing[/b] yourself.
                            I'll let it slip this time, because you're new to being a slave and all.
                            Try to hurt me again, though, I'll return the favor.
                            And I can assure you [b]my[/b] fangs are [b]much[/b] sharper than yours.
                            Anyway, you've made your choice.
                            If you're [b]lucky[/b], I might see fit to ask you again later.
                            But a little [i]kiss[/i] won't suffice next time.[/color]"
                            His words worry you far more than they should.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
