/**
 * Reward section of the forest bandit section.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditReward(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;
    
    var continueId = "banditRewardContinueButton";
    
    var scaryNoise = `  <div class="text">
                            You take a deep breath, before letting out a loud, terrifying, soul-piercing howl to the best of your abilities.
                            While you start off mimicking a wolf, your <span class="italic">outburst</span> turns into something different altogether nearing the end,
                            more resembling a low, unsteady growl than the high-pitched whine you started off with.
                        </div>
                        <div class="text">
                            You can <span class="italic">hear</span> the kobolds getting more anxious with every passing moment,
                            their leader rapidly losing control over his men.
                            You follow up your initial screech with a series of disconcerting noises, each one more unsettling than the last.
                        </div>
                        <div class="text center">
                            <span class="bold blue">
                                Run!
                            </span>
                        </div>
                        <div class="text">
                            Comes the insubordinate decision of one of the underlings, 
                            the kobold darting out of the clearing and into the woods as fast as his legs can take him.
                            He is quickly followed by two of his peers, with only the leader tenaciously staying behind for a little while longer, before relenting himself.
                            With a dissatisfied grunt, he hops off of the woman's face, threatening her to stay put or face the consequences one final time.
                        </div>
                        <div class="text">
                            She wisely abides to his demand, the dragoness lying still whilst the ringleader drags his remaining, 
                            unconscious henchman into the cover of the forest.
                            The final two members of the gang soon disappear from sight, as the other three had long before them.
                        </div>
                        <div class="text center">
                            <span class="bold">
                                You've managed to save the dragoness!
                            </span>
                        </div>
                        <div class="text">
                            You keep up your threatening sounds for a few moments more, to ensure that the gang has left for sure.
                            The woman removes her impromptu gag, wiping her muzzle as she rises to her feet.
                            She, too, seems a little disturbed by your audial show.
                            You figure you must be good at faking noises.
                        </div>
                        <div class="text">
                            Ceasing your spooky act, you slowly step out from behind your cover, and approach the dragoness.
                            She gasps as you come into view.
                            The fearful lady visibly goes through a myriad of different emotions.
                        </div>
                        <div class="text">
                            At first, your appearance startles her. 
                            She gasps in fright as her mind races to reason that you are <span class="italic">not</span> a ghost 
                            or some scary forest monster coming to eat her whole.
                            Then, an angry, hateful glare takes over her visage, thinking you're part of another, or perhaps even the same gang.
                            Her hands curl up into fists, yet her aggressive posture quickly fades to make room for a slightly more hospitable pose.
                            She gives you a questioning, doutbting, thinking look.
                            Then, finally, the dragoness manages to piece things together.
                        </div>
                        <div class="text">
                            She tilts her head, quizically, gracefully and somewhat gratefully at the same time.
                            Truly a diplomatic figure, capable of portraying so many emotions with such a simple nod.
                            She eyes you up and down for a few moments.
                            Then, she speaks, slowly, her words like honey to your ears, each of them ringing in your mind long after being uttered by the woman:
                        </div>
                        <div class="center">
                            <span class="bold pink">
                                Was it <span class="italic">you</span> who rescued me?
                            </span>
                        </div>
                        <div class="text">
                            Your turn to be dumbstruck.
                            You manage to respond to the woman's query with only a simple nod.
                            A small, courteous, genuine smile forms on her face.
                            It warms your very heart.
                            Dragons really are <span class="italic">magical</span> beings.
                        </div>
                        <div class="center">
                            <span class="bold pink">
                                I am lady Saphira, princess of the United Dragon Empire. And you, my savior, are...?
                            </span>
                        </div>
                        <div class="text">
                            Slightly awestruck, you barely manage to stammer out your name.
                            Along with it, you ask what the lady is doing out here, all alone in the forest.
                            You can hardly peel your eyes away from hers, as though you're stuck in a trance.
                        </div>`;
    
    var payment = `     [p]
                            You loudly and nervously state that you would like to offer the gang a deal.
                            Their leader instantly responds, a quizzical, yet sceptical look forming on his face.
                            "<span class="bold brightred">Deal? What deal?! Bad timing! Can't you see I...WE are busy?! Go away!</span>"
                            He frantically waves his one free arm in an attempt to dismiss you.
                            You hesitantly assure him that this is a deal he -- [b]they[/b] wouldn't want to miss out on.
                            He sighs annoyedly in response, but you [i]have[/i] seemingly caught the group's attention, for better or for worse.
                        [/p]
                        [p]
                            You cup your coin pouch.
                            Second thoughts race through your mind, but it is too late for you to back down now.
                            You slowly remove the hefty bundle from around your neck.
                            Staring at it longingly, you close your eyes and let out a sigh of your own.
                            You have to do this. 
                            For the safety of the dragoness. 
                            You [b]need[/b] to do this.
                        [/p]
                        [p]
                            Opening your eyes once more, you jiggle your purse, the golden coins within clattering about loudly.
                            You open up the small bag to show its contents are indeed authentic, to prove you're not trying to play a trick on the kobolds.
                            Then, you toss the pouch to the ground, right in front of you.
                            Their collective eyes remain greedily glued to it until you open your mouth to speak once more.
                        [/p]
                        [p]
                            You make the offer.
                            They leave the dragoness alone, they get the coins.
                            The leader immediately questions why he shouldn't just take [b]both[/b].
                            You hadn't given it much thought, so you are dumbstruck for a moment.
                            After a brief period of silence, you suddenly think of a sly and appropriate answer.
                            Your hesitation melts like snow on the first, sunny day of spring, as you begin to reason out loud.
                        [/p]
                        [p]
                            Right now, they have a choice.
                            Option one is for them to resume their business with the dragoness, and let you go on your merry way.
                            Option two is that they take up your offer, you step aside and let them take your gold, and they leave a lot richer than before.
                            Option three entails them trying to get both.
                            They lunge for you, you snag your pouch off the ground, and you bolt into the forest.
                            The dragoness escapes, and they get [i]neither[/i] the gold [i]nor[/i] the girl.
                            Heck, maybe they'll manage to catch [b]one[/i] of you, [i]if[/i] they're lucky.
                        [/p]
                        [p]
                            Your astute observation prompts a discussion amongst the kobolds.
                            While it's hard to follow all five of them chattering at the same time,
                            the underlings generally seem to agree with what you're saying.
                            The leader, meanwhile, continues to believe he can snag your gold [i]without[/i] letting the dragoness go,
                            but after a solid minute of heated arguing between him and his gang, he finally relents to the will of the majority.
                        [/p]
                        [p]
                            His face turns towards you once more, an unhappy look on his face.
                            "<span class="bold brightred">Fine.</span>" he practically spits out. "<span class="bold brightred">We take the gold.</span>"
                            The both of you exchange an uneasy nod.
                            The deal is done.
                        [/p]
                        [p]
                            The bandits let go of the dragoness' limbs.
                            She instantly removes the loincloth-gag from her mouth, and rises to her feet.
                            You carefully circle around them towards her, and they do their best to avoid you whilst beelining for your gold.
                            After verifying the contents of the pouch that was formerly yours, the ringleader gives both you and the dragoness a courteous bow,
                            resentment and reluctance still clearly plastered across his face.
                        [/p]
                        [p]
                            While unpleased with the deal his underlings are so keen on taking, he seems like a man of his word.
                            Bedgrudgingly, he speaks: "<span class="bold brightred">Pleasure doing business. We'll buy ten whores like her with this.</span>"
                            Then, with a wave of his hand, all five of the kobolds swiftly venture out of the clearing, disappearing into the forest.
                        [/p]
                        <div class="text center">
                            <span class="bold">
                                You've managed to save the dragoness!
                            </span>
                        </div>`;
    
    var paymentRock = ` [p]
                            You loudly and nervously state that you would like to offer the gang a deal.
                            Their leader instantly responds, a quizzical, yet sceptical look forming on his face.
                            "<span class="bold brightred">Deal? You throw rock, then offer deal?! Get lost before I gut you!</span>"
                            He threateningly waves his knife about in your direction.
                            You hesitantly assure him that this is a deal he wouldn't want to miss out on,
                            one that'll [b]more[/b] than make up for knocking out one of his comrades.
                            He sighs annoyedly in response, but you [i]have[/i] seemingly caught the group's attention, for better or for worse.
                        [/p]
                        [p]
                            You cup your coin pouch.
                            Second thoughts race through your mind, but it is too late for you to back down now.
                            You slowly remove the hefty bundle from around your neck.
                            Staring at it longingly, you close your eyes and let out a sigh of your own.
                            You have to do this. 
                            For the safety of the dragoness. 
                            You [b]need[/b] to do this.
                        [/p]
                        [p]
                            Opening your eyes once more, you jiggle your purse, the golden coins within clattering about loudly.
                            You open up the small bag to show its contents are indeed authentic, to prove you're not trying to play a trick on the kobolds.
                            Then, you toss the pouch to the ground, right in front of you.
                            Their collective eyes remain greedily glued to it until you open your mouth to speak once more.
                        [/p]
                        [p]
                            You make the offer.
                            They leave the dragoness alone, they get the coins.
                            The leader immediately questions why he shouldn't just take [b]both[/b].
                            You hadn't given it much thought, so you are dumbstruck for a moment.
                            After a brief period of silence, you suddenly think of a sly and appropriate answer.
                            Your hesitation melts like snow on the first, sunny day of spring, as you begin to reason out loud.
                        [/p]
                        [p]
                            Right now, they have a choice.
                            Option one is for them to resume their business with the dragoness, and let you go on your merry way.
                            Option two is that they take up your offer, you step aside and let them take your gold, and they leave a lot richer than before.
                            Option three entails them trying to get both.
                            They lunge for you, you snag your pouch off the ground, and you bolt into the forest.
                            Already a man down, 
                            there'll be nothing to prevent the dragoness from escaping, 
                            and they'll get [i]neither[/i] the gold [i]nor[/i] the girl.
                            Heck, maybe they'll manage to catch [b]one[/i] of you, [i]if[/i] they're lucky.
                        [/p]
                        [p]
                            Your astute observation prompts a discussion amongst the kobolds.
                            While it's hard to follow all four of them chattering at the same time,
                            the underlings generally seem to agree with what you're saying.
                            The leader, meanwhile, continues to believe he can snag your gold [i]without[/i] letting the dragoness go,
                            but after a solid minute of heated arguing between him and his gang, he finally relents to the will of the majority.
                        [/p]
                        [p]
                            His face turns towards you once more, an unhappy look on his face.
                            "<span class="bold brightred">Fine.</span>" he practically spits out. "<span class="bold brightred">We take the gold.</span>"
                            The both of you exchange an uneasy nod.
                            The deal is done.
                        [/p]
                        [p]
                            The bandits let go of the dragoness' limbs.
                            She instantly removes the loincloth-gag from her mouth, and rises to her feet.
                            You carefully circle around them towards her, and they do their best to avoid you whilst beelining for your gold,
                            only one of them concerned with strenuously dragging their unconscious friend along with.
                            After verifying the contents of the pouch that was formerly yours, the ringleader gives both you and the dragoness a courteous bow,
                            resentment and reluctance still clearly plastered across his face.
                        [/p]
                        [p]
                            While unpleased with the deal his underlings are so keen on taking, he seems like a man of his word.
                            Bedgrudgingly, he speaks: "<span class="bold brightred">Pleasure doing business. We'll buy ten whores like her with this.</span>"
                            Then, with a wave of his hand, three of the kobolds venture out of the clearing, 
                            disappearing into the forest, followed by the fourth tugging along the fifth.
                        [/p]
                        <div class="text center">
                            <span class="bold">
                                You've managed to save the dragoness!
                            </span>
                        </div>`;
    
    
    var postPay = `     [p]
                            As the bandits scurry off, the dragoness turns to face you.
                            A small, genuine smile forms on her face.
                            It warms your very heart.
                            Dragons truly are <span class="italic">magical</span> beings.
                            Then, she speaks, her words like honey to your ears, each of them ringing in your mind long after being uttered by the woman:
                        [/p]
                        [p]
                            "<span class="bold pink">I am lady Saphira, princess of the United Dragon Empire.
                                I am indebted to you, for your kind and most generous of actions.
                                That must have been quite a bit of money, for those vile creatures to release someone of my standing from their grasp.
                                May I know your name, my most beneficent of heroes?</span>"
                        [/p]
                        [p]
                            Slightly awestruck, you barely manage to stammer out your name.
                            Along with it, you ask what the lady is doing out here, all alone in the forest.
                            You can hardly peel your eyes away from hers, as though you're stuck in a trance.
                        [/p]`;
    
    var genReward = `   [p]
                            Noticing your sadness, the dragoness quickly changes the topic at hand.
                            A reward.
                            She wants to give you something for saving her, yet her own purse was plundered by the kobold bandits.
                            Picking up her deflated coin pouch off the leafy forest floor, she laments the entire ordeal for a couple of moments.
                        [/p]
                        [p]
                            While she has nothing of actual value left,
                            apart from her somewhat intact pride,
                            there is still [i]one[/i] thing she can give you.
                            Reaching into her bosom, the lady begins to fiddle with the fabric on the inside of her dress.
                            After a small bit of tangible frustration,
                            she pulls out a single, sharp ${global.kobold.inventory.createItemWithTooltip(new GoldenNeedle())}, 
                            which was properly concealed, hidden in her apparel.
                        [/p]
                        [p]
                            She hands the sharp object to you, as a keepsake.
                            It's the [i]least[/i] she can do to repay you.
                            Seeing the setting sun, she decides it's time to say goodbye.
                            And then, after condescendingly patting your head, 
                            the dragoness slowly walks out of the clearing, in the direction of the southern road.
                        [/p]`;
    
    var payReward = `   [p]
                            Noticing your sadness, the dragoness quickly changes the topic at hand.
                            A reward.
                            She wants to give you something for saving her, yet her own purse was plundered by the kobold bandits.
                            Picking up her deflated coin pouch off the leafy forest floor, she passes it to you.
                            You wear the empty bag around your neck, much like your previous money-container,
                            only this one is empty instead of being filled to the brim with much-needed money.
                        [/p]
                        [p]
                            While she has nothing of actual value left,
                            apart from her somewhat intact pride,
                            there is still [i]one[/i] thing she can give you.
                            Reaching into her bosom, the lady begins to fiddle with the fabric on the inside of her dress.
                            After a small bit of tangible frustration,
                            she pulls out a single, sharp ${global.kobold.inventory.createItemWithTooltip(new GoldenNeedle())}, 
                            which was properly concealed, hidden in her apparel.
                        [/p]
                        [p]
                            She hands the sharp object to you, as a keepsake.
                            It's the [i]least[/i] she can do to repay you.
                            Seeing the setting sun, she decides it's time to say goodbye.
                            And then, after condescendingly patting your head, 
                            the dragoness slowly walks out of the clearing, in the direction of the southern road.
                        [/p]`;

    var cRock = `       [p]
                            With the lady gone, you slowly drift out of your enamored state.
                            She had an undeniably powerful effect on you, which seems to fade along with her presence, if a bit delayed.
                            You wonder why she didn't use this [i]gift[/i] to stave off the bandits.
                            If she's even in control of it, that is.
                        [/p]
                        [p]
                            Oh well, some things aren't for simply minds like your own to understand.
                            You briefly shake your head to clear any lingering thoughts of Saphira, and after picking up your  you begin to make your way back home.
                        [/p]`;


    // PRIVATE FUNCTIONS \\     function privateFunction(){}
    
    function buildName() {
        var name = ctrl.bandit.rewardName();
        return global.parser.parse(`
                        [p]
                            "<span class="bold pink">Ah, ${name}. 
                            Am I pronouncing that right?
                            A very fitting name for someone of your...[i]stature[/i].
                            Well, my little saviour, until very recently, I was a guest in the keep of Varanar.
                            However, the atmosphere there has turned rather [i]grim[/i] ever since the human king ventured out to war.</span>"
                        [/p]
                        [p]
                            A troubled look grows on the princess' face.
                            It makes you feel absolutely [b]terrible[/b], as though you're going through the exact same emotions she must have felt.
                        [/p]
                        [p]
                            "<span class="bold pink">Without divulging into details, let us just say that the current governor and I do not see eye to eye.
                            In fact, he imprisoned my retinue, cast me from the keep, and outright banished me from the city.</span>"
                        [/p]
                        [p]
                            You attentively continue to listen, enthralled by her every word, [b]craving[/b] for more of the nigh-orgasmic melody of her voice.
                            She seems to be happy to be able to tell her tale to someone who [i]cares[/i], seemingly unaware of her own enchanting aura.
                        [/p]
                        [p]
                            "<span class="bold pink">So I was making my lonely way southwards, to the nearby town of Salamar,
                            when I spotted a band of misfits headed my way, their caravan taking up most of the road.
                            Knowing how [i]uncivilized[/i] soldiers can get, I sought refuge in the forest, only to be assaulted by a band of [i]your[/i] kind.
                            And the rest, I believe you can piece together for yourself.</span>"
                        [/p]
                        [p]
                            You give the lady a slight nod. 
                            You can feel her [i]influence[/i] on you lessen, 
                            enough for you to [b]think[/b] for yourself instead of your mind simply echoing [i]her[/i] words.
                            You ask the woman if she needs an [i]escort[/i] to get to...Saramar, was it?
                            You mean, you've always dreamt of being a knight, and this is the closest you've ever gotten to kind of not really fulfilling that dream!
                        [/p]
                        [p]
                            Sadly, the lady turns you down, stating she can't [i]afford[/i] being seen with one of [i]your[/i] kind.
                            Her rejection makes you feel physically ill, devestated to the very core,
                            but the feeling rapidly vanishes, leaving only the disappointment of your broken childhood dreams in its wake.
                        [/p]`);
    }
    
    function buildContinue(){
        var didRock = (ctrl.bandit.getArrivalChoice() === ForestBanditArrivalChoiceEnum.ROCK);
        return global.parser.parse(`
                        [p]
                            With the lady gone, you slowly drift out of your enamored state.
                            She had an undeniably powerful effect on you, which seems to fade along with her presence, if a bit delayed.
                            You wonder why she didn't use this [i]gift[/i] to stave off the bandits.
                            If she's even in control of it, that is.
                        [/p]
                        [p]
                            Oh well, some things aren't for simply minds like your own to understand.
                            You briefly shake your head to clear any lingering thoughts of Saphira, 
                            and ${didRock ? "after picking up your rock once more, " : ""} you begin to make your way back home.
                        [/p]`);
    }
    
    function buildScaryNoise() {
        var toReturn = scaryNoise;
        toReturn += buildName();
        toReturn += global.parser.parse(genReward);
        toReturn += buildContinue();
        return toReturn;
    }
    
    function buildPay() {
        var didRock = (ctrl.bandit.getArrivalChoice() === ForestBanditArrivalChoiceEnum.ROCK);
        var toReturn;
        if(didRock){
            toReturn = global.parser.parse(paymentRock);
        } else {
            toReturn = global.parser.parse(payment);
        }
        toReturn += global.parser.parse(postPay);
        toReturn += buildName();
        toReturn += global.parser.parse(payReward);
        toReturn += buildContinue();
        return toReturn;
    }

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var source = ctrl.bandit.getRewardSource();
        var toReturn = `<div class=text>reward - no source</div>`;
        if (source === ForestBanditRewardSourceEnum.SCARYNOISE) {
            toReturn = buildScaryNoise();
            toReturn += ctrl.bandit.rewardScary();
        }
        if (source === ForestBanditRewardSourceEnum.PAY) {
            toReturn = buildPay();
            toReturn += ctrl.bandit.rewardPay();
        }
        return toReturn;
    }

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.bandit.hasRewardContinued();
        var choice = `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }
    
    /**
     * Loads and displays the next part.
     */
    function loadNextPart() {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(ctrl.homeSceneName);
        });
    }
    
    /**
     * Adds a listener to the continue button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.rewardContinue();
            loadNextPart();
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditReward";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (!ctrl.bandit.hasRewardSource()) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += buildChoice();
        part += `</div>`;
        
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (!ctrl.bandit.hasRewardSource()) {
            return;
        }

        // Register children listeners here.

        if (ctrl.bandit.hasRewardContinued()) {
            return;
        }

        registerContinueListener();
    };
}

/**
 * Sources for the reward of the bandit section.
 */
var ForestBanditRewardSourceEnum = {
    SCARYNOISE: 1,
    PAY: 2,
    PERSUASION: 3
};
