/**
 * Barn section of the farm scene.
 * @param {BreedingFarmController} controller The breeding farm controller.
 */
function NotBarnAgree(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = "notBarnAgreeButton";
    
    var next = new NotBarnAgreeSex(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        var toReturn = `[p]
                            While you internally hold some doubts,
                            you tell Cassidy that you don't see how a life without worries, full of sex,
                            with a constant supply of free food and a [b]good-looking[/b] caretaker such as herself could be a bad thing.
                            Your flattering reply seems to please the woman, a broad smirk forming on her face, visible even though she doesn't look back.
                            A loud [i]click[/i] resonates from the door lock, and with a simple push, the vixen opens up the way into her home.
                        [/p]
                        [p]
                            The two of you step inside.
                            You first, the vulpine second.
                            She closes the door behind her, using nothing but her tail.
                            The inside of her home looks every bit as luxurious as the outside.
                            A myriad of paintings line the walls, interspersed with gilded candelabras containing lit candles.
                            The entrance hallway you find yourself in is at least three times the size of your little shack in the woods.
                            You can't say you're left unamazed.
                        [/p]
                        [p]
                            After taking in the splendour on display for a few moments, you turn around to face your hostess.
                            She stares at you with a lusty, predatory look.
                            Now that the two of you are alone, she no longer needs to hold back.
                            One of her hands has already slinked between her own legs,
                            subconsciously rubbing away at her inner thigh.
                            You can tell that she's just about ready to [b]pounce[/b] at you,
                            to [b]leap[/b] ontop of you and [b]fuck[/b] until you're both sated.
                            The two of you wordlessly exchange sultry smiles.
                            Your inaction only seems to entice her further,
                            until finally, she can hold herself back no longer.
                        [/p]`;
        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildContinueChoice() {
        var disabled = ctrl.postnotbarn.has() ? "disabled" : "";
        var isSelected = ctrl.postnotbarn.has();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildContinueChoice();
        choice += `</div>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.postnotbarn.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "notBarnAgree";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.notbarn.get() !== NotBarnChoice.AGREE) {
            return "";
        }
        global.ui.applyTheme("hamlet_mansion");
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.notbarnAgreeChange();
        part += buildChoice();
        part += next.build();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.notbarn.get() !== NotBarnChoice.AGREE) {
            return;
        }

        next.registerListeners();

        if (ctrl.postnotbarn.has()) {
            return;
        }

        registerContinueListener();
    };
}
